Message Ports
=============

Communicating between applications using plain old TCP sockets can be lot of work. I mean, it's worse without TCP, so it's great that it's there, but it's still up to your program to turn those "hey a client connected!" and "yo, here's some data I just got from it" events that the operating system gives you into something that make sense for your application. It's up to you to handle framing and buffering and timeouts and all those technical details in your program.

One way abstract away all that stuff is to adopt well known application protocol. Even if your application isn't a perfect fit for the message format of the protocol you can be pretty sure that you'll be able to find libraries for both ends of the connection that abstract away all TCP details.

Adopting the HTTP protocol and associated client/server libraries (the ones in node.js are pretty sweet) is one option, using Message Ports is another.

Message Ports makes use of the awesome ZeroMQ(*) library to do all the heavy lifting. In fact it's really just a friendly API on top of ZeroMQ that focuses on applications communicating over TCP ports.

(*) ZeroMQ sounds like ActiveMQ and RabbitMQ but it really isn't anything like those. So the name is kinda confusing.

ZeroMQ is fairly mature but the Message Ports library is still fairly new, feedback is welcome.

Message Ports is a really good fit for applications that run on the same local network or same physical machine. It's not a good fit for applications that need to talk over the public internet. In that case you probably want HTTP over SSL with some kind of authentication and perhaps a good firewall.
